#########################################################################
############### CORRECTION TP2 : INITIATION AU LOGICIEL R ###############
#########################################################################

# Exercice 1 : Comparaison de distributions

#Q1

curve(dnorm(x),from=-4, to=4)
title("Comparaison de distributions")
curve(dt(x,5), add=TRUE,col=2)
curve(dt(x,30), add=TRUE,col=3)

#Q2

dev.new()
x=seq(-4,4,0.01)
plot(x,dnorm(x), type="l")
lines(x,dt(x,5),col="2")
lines(x, dt(x,30), col="3")
title("Comparaison de distributions")
legend(x=-4,y=0.4,legend=c("loi normale","loi de Student  5 ddl", "loi de Student  30 ddl"),col=1:3,lwd=1,cex=0.7)

# Exercice 2: Reprsentation d'un nuage de points

# Q1

ozone=read.table("ozone.txt",header=TRUE)
plot(maxO3~T12,data=ozone)

# Q2

plot(maxO3~T12,data=ozone,type="l")

# Q3

ordre=order(ozone[,"T12"])
plot(maxO3~T12,data=ozone[ordre,],type="b")
# Q4 moyenne
abline(h=mean(ozone$maxO3), col="red", lty=2)
# Q5 droite de rgression
abline(a=-27.42, b=5.469, col="blue")

# Exercice 3 : Loi des grands nombres

#Q1

set.seed(123)
ech=rbinom(1000,1,p=0.6)

#Q2

plot(cumsum(ech)/(1:1000),type="l")
abline(h=0.6,col=2)

# Exercice 4: TCL pour la loi de Bernoulli

#Q1

p=0.5
N=10
n=10000
U10=(rbinom(n,N,p)-N*p)/sqrt(N*p*(1-p))

N=100
U100=(rbinom(n,N,p)-N*p)/sqrt(N*p*(1-p))

N=1000
U1000=(rbinom(n,N,p)-N*p)/sqrt(N*p*(1-p))

#Q2

par(mfrow=c(3,1))
hist(U10,xlim=c(-4,4),ylim=c(0,0.6),prob=TRUE)
curve(dnorm(x),from=-4, to=4,add=TRUE,col=2)
hist(U100,xlim=c(-4,4),ylim=c(0,0.6),prob=TRUE)
curve(dnorm(x),from=-4, to=4,add=TRUE,col=2)
hist(U1000,xlim=c(-4,4),ylim=c(0,0.6),prob=TRUE)
curve(dnorm(x),from=-4, to=4,add=TRUE,col=2)

# Exercice 5 : Intervalle de confiance pour une proportion

#Q1

n=1000
N=1e4
p=0.3
a=0.05
mat=matrix(rbinom(n*N,1,p),ncol=N)
dim(mat)

#Q2

moyenne=apply(mat,2,mean)
std=apply(mat,2,sd)

length(moyenne)
length(std)

#Q3

borne.inf=moyenne-qnorm(1-a/2)*std/sqrt(n)
borne.sup=moyenne+qnorm(1-a/2)*std/sqrt(n)

head(cbind(borne.inf,borne.sup))

#Q4

prop=mean(borne.inf<=p & p <=borne.sup)
prop

# Exercice 6 : Test sur la moyenne d'un chantillon gaussien

#Q1

n=10
N=1e4
m=1
a=0.05
mat=matrix(rnorm(n*N,mean=m,sd=1),ncol=N)

#Q2

moyenne=apply(mat,2,mean)
std=apply(mat,2,sd)

#Q3

seuil=qt(1-a/2,n-1)*std/sqrt(n)

#Q4

m0=1
comparaison=abs(moyenne - m0)>seuil
mean(comparaison)


